#! don't /usr/bin/perl -w

$markerlocfile = $ARGV[0];#name of file that contains physical location of markers
$inputboundryfile = $ARGV[1];#name of file that contains boundry scores (*.mbp)
$inputblocksfile = $ARGV[2];#name of the file that contains optimal segmentation info
$outputboundryfile = "$inputboundryfile.physical";#default name of file to be created from $inputboundryfile with marker physical location info
$outputblocksfile = "$inputblocksfile.physical";#default name of file to be created from $inputblocksfile with marker physical location info

#allows for possiblity of 4th argument to be name of outputboundryfile
if($ARGV[3])
{
	$outputboundryfile = $ARGV[3];
}
#allows for possiblity of 5th argument to be name of outputblocksfile
if($ARGV[4])
{
	$outputblocksfile = $ARGV[4];
}


print "\tchangevalues.pl called!\n";
print "\tOpening $markerlocfile for reading.\n";
open(MARK,$markerlocfile) or die "\tCannot open $markerlocfile.";
$nummarkers = 0;
while($line = <MARK>)
{
	if($line !~ /^\s/)
	{
		#print $line;
		push(@markerlocations, $line);
		$nummarkers++;
	}
}
print "\tNumber of markers in $markerlocfile is $nummarkers\n";
close(MARK);

print "\tOpening $inputboundryfile for reading.\n";
open(BOUND, $inputboundryfile) or die "\tCannot open $inputboundryfile.\n";
$numofboundries=0;
while($line = <BOUND>)
{
	push(@data,$line);
	$numofboundries++;
}
close(BOUND);


print "\tWriting $outputboundryfile.\n";
if($numofboundries+1 == $nummarkers)
{
	open(OUTBOUND,">$outputboundryfile");
	for($i=0;$i<$numofboundries;$i++)
	{
		@elelist = split(/\s+/,$data[$i]);
		$elelist[0] = ((($markerlocations[$i]+$markerlocations[$i+1])/2.0));
		print OUTBOUND "$elelist[0] ";
		print OUTBOUND "$elelist[1] ";
		print OUTBOUND "$elelist[2]\n";
	}
	close(OUTBOUND);
}

else
{
	print "\tError in $markerlocfile file:\n";
	$expected =$numofboundries+1;
	print "\t$expected markers are expected in the file.\n";
}

print "\tOpening $inputblocksfile for reading\n";
open(INBLOCK,$inputblocksfile) or die "\tCannot open $inputblocksfile.\n";
$numofblocklines =0;
while($line = <INBLOCK>)
{
	push(@blockdata,$line);
	$numofblocklines++;
}
close(INBLOCK);
print "numofblocklines = $numofblocklines\n";


open(OUTBLOCK, ">$outputblocksfile");
foreach $ele(@blockdata)
{
	@list = split(/\s+/,$ele);
	$lengthoflist = @list;
	for($i=0;$i<$lengthoflist;$i++)
	{
			if(($list[$i] eq 'B') or ($list[$i] eq 'G'))
			{
				$i++;
				$list[$i] = $markerlocations[$list[$i]]-$markerlocations[0]+1;
				$i++;
				$list[$i] = $markerlocations[$list[$i]]-$markerlocations[0]+1;
			} 		
	}

	print OUTBLOCK "@list\n";
}
close(OUTBLOCK)
